#ifndef _responseparam_h
#define _responseparam_h

#include "packet.h"
#include "controller.h"

#include <sys/types.h>


/* Creates data and metadata for a respcontrol packet.
 * Returns data size.
 */
ssize_t EncodeResponseParam(
		struct metadata *m, /* Out */
		uint8_t *data,      /* Out */
		size_t data_size,   /* Data buffer max size */
		const struct controller_message *cm); /* In */

/* Decode a metadata and data to populate a message
 * Returns 0 on success, -1 on failure
 */
int DecodeResponseParam(
		struct controller_message *cm, /* Out */
		const struct metadata *m,      /* In */
		const uint8_t * data);         /* In */


#endif
